package de.mcs.tools.sps.mnemonic;

import static org.junit.jupiter.api.Assertions.assertEquals;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;

import de.mcs.tools.sps.exceptions.SyntaxError;

class TestNOP {

  @Test
  void testNOP() throws SyntaxError {
    NOP nop = new NOP("NOP");
    assertEquals(0x00, nop.getByte());

    Assertions.assertThrows(SyntaxError.class, () -> {
      NOP nop1 = new NOP("NOP akfhaskh");
      nop1.checkArgument();
    });
  }

  @Test
  void testNOPFactory() throws SyntaxError {
    Mnemonic mnemonic = MnemonicFactory.getMnemonic("NOP", 0);
    assertEquals(NOP.class, mnemonic.getClass());

    Assertions.assertThrows(SyntaxError.class, () -> {
      MnemonicFactory.getMnemonic("NOP kdfhkalsfh", 0);
    });

    Assertions.assertThrows(SyntaxError.class, () -> {
      MnemonicFactory.getMnemonic("NOP 0x12", 0);
    });

    Assertions.assertThrows(SyntaxError.class, () -> {
      MnemonicFactory.getMnemonic("NOP 12", 0);
    });

    Assertions.assertThrows(SyntaxError.class, () -> {
      MnemonicFactory.getMnemonic("NOP 0b01001010", 0);
    });

    mnemonic = MnemonicFactory.getMnemonic("Nop", 2);
    assertEquals(NOP.class, mnemonic.getClass());

    mnemonic = MnemonicFactory.getMnemonic("nop", 3);
    assertEquals(NOP.class, mnemonic.getClass());
    assertEquals(3, mnemonic.getLineNumber());

    mnemonic = MnemonicFactory.getMnemonic("nop", 4);
    assertEquals(NOP.class, mnemonic.getClass());
  }
}
